

//授权组件
	var authllComponent = {
		template:`
			<div>
				<div id="" style="display: inline-block;width: 100%;margin-top: 10px;">
				
					<div  style="float: left; width: 15%;background-color: #ECF5FF;">
					<el-input v-model="sid" placeholder="请输入系列号" clearable></el-input>
					</div>
					<div  style="float: left; width: 15%;background-color: #ECF5FF;">
					<el-input v-model="iid" placeholder="请输入编码" clearable></el-input>
					</div>
					<div style="float: left;margin-left: 5px;">
					<el-button id ="bt_search" plain type="primary" icon="el-icon-search" @click="getAuthHisPos()">搜索</el-button>
					</div>
					
					<div style="float: left; margin-left: 5px;">
						<el-button id ="bt_export" plain type="primary" icon="el-icon-document" @click="exportAuthPos()">导出</el-button>
					</div>
				</div>
				<div class="span">
					<el-table
						:data="tableData"
						style="width: 100%"
						:height="tHeight"
						:cell-style="{background:'#304156'}"
						border
						>
					    <el-table-column
							fixed
					      prop="series"
					      label="仪器系列号"
					      width="100">
					    </el-table-column>
					    <el-table-column
							fixed
					      prop="instrument_id"
					      label="仪器编码"
					      width="80">
					    </el-table-column>
						<el-table-column
						  prop="auth_date"
						  label="授权时间"
						  width="160">
						</el-table-column>
					    <el-table-column
					      prop="expire_date"
					      label="到期时间"
					      width="160">
					    </el-table-column>
						
						<el-table-column
							 prop="longitude"
							 label="授权经度"
							 width="100">
						</el-table-column>
						
						<el-table-column
							 prop="latitude"
							 label="授权纬度"
							 width="100">
						</el-table-column>
						  <el-table-column
						  	 prop="report_longitude"
						  	 label="使用经度"
						  	 width="100">
						  </el-table-column>
						  
						  <el-table-column
						  	 prop="report_latitude"
						  	 label="使用纬度"
						  	 width="100">
						  </el-table-column>
						  <el-table-column
							 prop="wellname"
							 label="井名"
							 :width="flexColumnWidth('wellname',tableData)">
						  </el-table-column>
						  <el-table-column
						  	 prop="x"
						  	 label="大地坐标X"
						  	 width="100">
						  </el-table-column>
						  
						  <el-table-column
						  	 prop="y"
						  	 label="大地坐标Y"
						  	 width="100">
						  </el-table-column>
						  <el-table-column
						  	 prop="auth_mark"
						  	 label="工作字"
						  	 width="60">
						  </el-table-column>  
						    <el-table-column
						  	 prop="authorizer"
						  	 label="授权人"
						  	 width="80">
						    </el-table-column>
					  </el-table>
				</div>
			  
				<div class="block" style="margin-top: 10px;">
				    <span class="demonstration" style="background-color: #ECF5FF;"></span>
				    <el-pagination
				      @size-change="handleSizeChange"
				      @current-change="handleCurrentChange"
				      :current-page="currentPage"
				      :page-sizes="[50,100, 200, 300]"
				      :page-size="pagesize"
				      layout="total, sizes, prev, pager, next, jumper"
				      :total="recordTotal" style="background-color: #ECF5FF;">
				    </el-pagination>
				  </div>
			</div>
		`,
	  data(){
		  // 获取当前屏幕的分辨率
		  let screenW = window.screen.width;
		  let screenH = window.innerHeight;
		  console.log("screen width:",screenW);
		  console.log("screen height:",screenH);
		  
		  return {
			tHeight:screenH-202,
			tableData: [],
			sid:'',
			iid:'',
			currentPage: 1,
			pagesize:50,
			recordTotal:0,
		  }
		},
		mounted() {
			
			var _this = this;
			
			var objs;
			axios.post('/deescloud/getAuthHisPos', {
				opuser:localStorage.getItem("online_user"),
				opuser_uuid:localStorage.getItem("uuid"),
			    index: this.$data.currentPage,
			    count: this.$data.pagesize
			  })
			  .then(function (response) {
				  
			    console.log(response.data);
				objs = response.data.data;
				rcnt = response.data.total;
				_this.$data.tableData = objs;
				_this.$data.recordTotal = rcnt;
			  })
			  .catch(function (error) {
			    console.log(error);
			  });
		},
	methods: {
		exportAuthPos(){
			document.getElementById("bt_export").blur();
			
			var _this = this;
			axios.post('deescloud/getAuthorizePosCsv',{
				sid:_this.$data.sid,
				iid:_this.$data.iid,
			})
			.then(function (response) {
				console.log(response.data);
				var fileid = response.data.fileId;
				
				var downUrl = 'file/'+fileid;
				downloadUrl("仪器经纬度使用统计.xlsx",downUrl);
			})
			.catch(function (error) {
				console.log(error);
			});
		},
		
		getAuthHisPos(){
			document.getElementById("bt_search").blur();
			
			this.$data.currentPage=1;
			
			var _this = this;
			
			var objs;
			axios.post('/deescloud/getAuthHisPos', {
				opuser:localStorage.getItem("online_user"),
				opuser_uuid:localStorage.getItem("uuid"),
				sid:_this.$data.sid,
				iid:_this.$data.iid,
				index: this.$data.currentPage,
				count: this.$data.pagesize
			  })
			  .then(function (response) {
				console.log(response.data);
				objs = response.data.data;
				rcnt = response.data.total;
				_this.$data.tableData = objs;
				_this.$data.recordTotal = rcnt;
			  })
			  .catch(function (error) {
				console.log(error);
			  });
		},
		  
		handleSizeChange(val) {
			  this.$data.pagesize = val;
			  
			  var _this = this;
			  this.$data.currentPage = 1;
			  var objs;
			  axios.post('/deescloud/getAuthHisPos', {
					opuser:localStorage.getItem("online_user"),
					opuser_uuid:localStorage.getItem("uuid"),
					sid:_this.$data.sid,
					iid:_this.$data.iid,
					index: this.$data.currentPage,
					count: this.$data.pagesize
				})
				.then(function (response) {
				  console.log(response.data);
				objs = response.data.data;
				rcnt = response.data.total;
				_this.$data.tableData = objs;
				_this.$data.recordTotal = rcnt;
				})
				.catch(function (error) {
				  console.log(error);
				});
		},
		handleCurrentChange(val) {
		  this.$data.currentPage = val;
		  
		  var _this = this;
		  
		  var objs;
		  axios.post('/deescloud/getAuthHisPos', {
					opuser:localStorage.getItem("online_user"),
					opuser_uuid:localStorage.getItem("uuid"),
					sid:_this.$data.sid,
					iid:_this.$data.iid,
					index: this.$data.currentPage,
					count: this.$data.pagesize
				})
				.then(function (response) {
				  console.log(response.data);
				objs = response.data.data;
				rcnt = response.data.total;
				_this.$data.tableData = objs;
				_this.$data.recordTotal = rcnt;
				})
				.catch(function (error) {
				  console.log(error);
				});
		},
		
		flexColumnWidth(str, tableData, flag = 'max') {
		  // str为该列的字段名(传字符串);tableData为该表格的数据源(传变量);
		  // flag为可选值，可不传该参数,传参时可选'max'或'equal',默认为'max'
		  // flag为'max'则设置列宽适配该列中最长的内容,flag为'equal'则设置列宽适配该列中第一行内容的长度。
		  
		  let maxContext = new Array();
		  
		  str = str + ''
		  let columnContent = ''
		  if (!tableData || !tableData.length || tableData.length === 0 || tableData === undefined) {
		    return '120px'
		  }
		  if (!str || !str.length || str.length === 0 || str === undefined) {
		    return '120px'
		  }
		  if (flag === 'equal') {
		    // 获取该列中第一个不为空的数据(内容)
		    for (let i = 0; i < tableData.length; i++) {
		      if (tableData[i][str].length > 0) {
		        // console.log('该列数据[0]:', tableData[0][str])
		        columnContent = tableData[i][str]
		        break
		      }
		    }
		  } else {
		    // 获取该列中最长的数据(内容)
		    let index = 0
		    for (let i = 0; i < tableData.length; i++) {
		      if (tableData[i][str] === null) {
		        return
		      }
		      const now_temp = tableData[i][str] + ''
		      const max_temp = tableData[index][str] + ''
		      if (now_temp.length >= max_temp.length) {
		        index = i
		      }
		    }
		    columnContent = tableData[index][str]
			
			maxContext.push(columnContent);
		  }
		  // console.log('该列数据[i]:', columnContent)
		  // 以下分配的单位长度可根据实际需求进行调整
		  
		  //console.log(columnContent);
		  let max_flex_width = 0
		  
		  for (let i = 0; i < maxContext.length; i++) {
			let flexWidth = 0;
		  	for (const char of maxContext[i]) {
		  	  if ((char >= 'A' && char <= 'Z') || (char >= 'a' && char <= 'z')) {
		  	    // 如果是英文字符，为字符分配8个单位宽度
		  	    flexWidth += 8
		  	  } else if (char >= '\u4e00' && char <= '\u9fa5') {
		  	    // 如果是中文字符，为字符分配15个单位宽度
		  	    flexWidth += 15
		  	  } else {
		  	    // 其他种类字符，为字符分配8个单位宽度
		  	    flexWidth += 8
		  	  }
		  	}
			
			if (flexWidth>max_flex_width) {
				max_flex_width = flexWidth;
				console.log(maxContext[i]);
			}
		  }
		  
		  if (max_flex_width < 120) {
		    // 设置最小宽度
		    max_flex_width = 120
		  }
			if (max_flex_width > 300) {
			 // 设置最大宽度
			 max_flex_width = 300
			}
		  
		  //flexWidth = flexWidth;//20-padding
		  console.log("max_flex_width:",max_flex_width);
		  return max_flex_width + 'px'
		},
		
	  }
	}
			